=== debian/control ===
Source: ros-melodic-mvsim
Section: misc
Priority: optional
Maintainer: Jose-Luis Blanco-Claraco <jlblanco@ual.es>
Build-Depends: debhelper (>= 9.0.0), cmake, libboost-all-dev, libbox2d-dev, libgtest-dev <!nocheck>, libprotobuf-dev, libprotoc-dev, libzmq3-dev, protobuf-compiler, pybind11-dev, python3-protobuf, python3-venv, ros-melodic-catkin, ros-melodic-dynamic-reconfigure, ros-melodic-mrpt2, ros-melodic-nav-msgs, ros-melodic-ros-environment, ros-melodic-roscpp, ros-melodic-sensor-msgs, ros-melodic-tf2, ros-melodic-tf2-geometry-msgs, ros-melodic-visualization-msgs, unzip, wget
Homepage: https://wiki.ros.org/mvsim
Standards-Version: 3.9.2

Package: ros-melodic-mvsim
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, libbox2d-dev, libprotobuf-dev, libprotoc-dev, libzmq3-dev, protobuf-compiler, pybind11-dev, python3-protobuf, python3-venv, ros-melodic-dynamic-reconfigure, ros-melodic-mrpt2, ros-melodic-nav-msgs, ros-melodic-roscpp, ros-melodic-sensor-msgs, ros-melodic-tf2, ros-melodic-tf2-geometry-msgs, ros-melodic-visualization-msgs, unzip, wget
Description: A lightweight multivehicle simulation framework.
